;;;  This is an adaptation of the elevator that appears in the IJCAI-97
;;;  paper on ConGolog.  The code is in reactive-elevator-run.scm.

(include "reactive-elevator-run.scm")

;;;  In this version, ERGO is used with TCP in a basic way
;;;     - actions generated by the program are simply printed
;;;     - exogenous actions arrive over TCP port 8234

;;;  To use this elevator, run this program, and in another window, do 
;;;     > telnet localhost 8234
;;;  from which exogenous actions can be entered

(define-interface 'out write-endogenous)

(define-interface 'in
  (let ((ports (open-tcp-server 8234)))
    (displayln "Ready to receive exogenous actions!" (cadr ports))
    (lambda () (display "Act: " (cadr ports)) (read (car ports)))))

(define (main) (ergo-do #:mode 'online control))
